package be.iminds.ilabt.jfed.restapi;

import be.iminds.ilabt.jfed.restapi.json.SpeaksForCredential;
import be.iminds.ilabt.jfed.restapi.json.SpeaksForCredentialBuilder;
import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.util.jsonld.UriTool;
import be.iminds.ilabt.util.jsonld.iface.JsonLdObjectBuilder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.net.URI;
import java.util.List;

/**
 * JFedRestDerivedUriGenerator
 */
public class JFedRestDerivedUriGenerator implements UriTool.DerivedUriGenerator {
    private static final Logger LOG = LoggerFactory.getLogger(JFedRestDerivedUriGenerator.class);

    @Override
    public void addDerivedUri(JsonLdObjectBuilder builder, UriTool uriTool) {
        //nothing here
    }

    @Override
    public void addForeignUri(JsonLdObjectBuilder builder, UriTool uriTool) {
        if (builder instanceof SpeaksForCredentialBuilder) {
            SpeaksForCredentialBuilder speaksForCredentialBuilder = (SpeaksForCredentialBuilder)builder;
            GeniUrn speakingFor = speaksForCredentialBuilder.getSpeakingFor();
            if (speakingFor == null) {
                LOG.warn("addDerivedUri called on ServerGlimpseBuilder without Server ID");
            } else {
                URI uri = uriTool.getUriUsingFedmonObject(
                        SpeaksForCredential.class,
                        speakingFor.getEncodedTopLevelAuthority_withoutSubAuth()+"/"+speakingFor.getEncodedResourceName());
                speaksForCredentialBuilder.setUri(uri);
            }
        }
    }
}
